Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/CrossValidation.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/CrossValidation.cs	(revision 8964)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/CrossValidation.cs	(revision 8965)
@@ -73,4 +73,5 @@
       RegisterEvents();
       if (Algorithm != null) RegisterAlgorithmEvents();
+      if (Problem != null) Problem.Reset += (o, e) => OnProblemChanged();
     }
 
@@ -521,6 +522,4 @@
     private void RegisterEvents() {
       Folds.ValueChanged += new EventHandler(Folds_ValueChanged);
-      SamplesStart.ValueChanged += new EventHandler(SamplesStart_ValueChanged);
-      SamplesEnd.ValueChanged += new EventHandler(SamplesEnd_ValueChanged);
       RegisterClonedAlgorithmsEvents();
     }
@@ -530,15 +529,4 @@
     }
 
-    private bool samplesChanged = false;
-    private void SamplesStart_ValueChanged(object sender, EventArgs e) {
-      samplesChanged = true;
-      if (Problem != null) Problem.ProblemData.TrainingPartition.Start = SamplesStart.Value;
-      samplesChanged = false;
-    }
-    private void SamplesEnd_ValueChanged(object sender, EventArgs e) {
-      samplesChanged = true;
-      if (Problem != null) Problem.ProblemData.TrainingPartition.End = SamplesEnd.Value;
-      samplesChanged = false;
-    }
 
     #region template algorithms events
@@ -571,5 +559,4 @@
       EventHandler handler = ProblemChanged;
       if (handler != null) handler(this, EventArgs.Empty);
-      if (samplesChanged) return;
 
       SamplesStart.Value = 0;
@@ -593,7 +580,4 @@
       } else
         SamplesEnd.Value = 0;
-
-      SamplesStart_ValueChanged(this, EventArgs.Empty);
-      SamplesEnd_ValueChanged(this, EventArgs.Empty);
     }
 
@@ -689,6 +673,6 @@
       lock (locker) {
         if (!stopPending && ExecutionState == ExecutionState.Started) {
-          IAlgorithm preparedAlgorithm = clonedAlgorithms.Where(alg => alg.ExecutionState == ExecutionState.Prepared ||
-                                                                       alg.ExecutionState == ExecutionState.Paused).FirstOrDefault();
+          IAlgorithm preparedAlgorithm = clonedAlgorithms.FirstOrDefault(alg => alg.ExecutionState == ExecutionState.Prepared ||
+                                                                                alg.ExecutionState == ExecutionState.Paused);
           if (preparedAlgorithm != null) preparedAlgorithm.Start();
         }
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisProblem.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisProblem.cs	(revision 8964)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisProblem.cs	(revision 8965)
@@ -357,5 +357,4 @@
       Description = data.Description;
       ProblemData = data;
-      OnReset();
     }
 
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/DataAnalysisProblem.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/DataAnalysisProblem.cs	(revision 8964)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/DataAnalysisProblem.cs	(revision 8965)
@@ -102,5 +102,4 @@
       Description = data.Description;
       ProblemData = data;
-      OnReset();
     }
 
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/OnlineCalculators/OnlineMeanAndVarianceCalculator.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/OnlineCalculators/OnlineMeanAndVarianceCalculator.cs	(revision 8964)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/OnlineCalculators/OnlineMeanAndVarianceCalculator.cs	(revision 8965)
@@ -73,5 +73,5 @@
 
     public void Add(double x) {
-      if (double.IsNaN(x) || double.IsInfinity(x) || x > 1E13 || x < -1E13 || (errorState & OnlineCalculatorError.InvalidValueAdded) > 0) {
+      if (double.IsNaN(x) || double.IsInfinity(x) || (errorState & OnlineCalculatorError.InvalidValueAdded) > 0) {
         errorState = errorState | OnlineCalculatorError.InvalidValueAdded;
         varianceErrorState = errorState | OnlineCalculatorError.InvalidValueAdded;