Index: branches/RuntimeOptimizer/HeuristicLab.Optimization.Views/3.3/ProblemView.cs
===================================================================
--- branches/RuntimeOptimizer/HeuristicLab.Optimization.Views/3.3/ProblemView.cs	(revision 8961)
+++ branches/RuntimeOptimizer/HeuristicLab.Optimization.Views/3.3/ProblemView.cs	(revision 8971)
@@ -57,4 +57,5 @@
         IEnumerable<Type> viewTypes = MainFormManager.GetViewTypes(consumer.GetType(), true);
         Type genericView = viewTypes.Where(x => x.IsSubclassOf(neededViewType)).First();
+        ProblemInstanceConsumerViewHost.Content = null; //necessary to enable the change of the ViewType
         ProblemInstanceConsumerViewHost.ViewType = genericView;
         ProblemInstanceConsumerViewHost.Content = consumer;
Index: branches/RuntimeOptimizer/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBoxPlotView.cs
===================================================================
--- branches/RuntimeOptimizer/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBoxPlotView.cs	(revision 8961)
+++ branches/RuntimeOptimizer/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBoxPlotView.cs	(revision 8971)
@@ -75,5 +75,5 @@
       Content.CollectionReset += new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_CollectionReset);
       Content.UpdateOfRunsInProgressChanged += new EventHandler(Content_UpdateOfRunsInProgressChanged);
-      Content.AlgorithmNameChanged += new EventHandler(Content_AlgorithmNameChanged);
+      Content.OptimizerNameChanged += new EventHandler(Content_AlgorithmNameChanged);
       RegisterRunEvents(Content);
     }
@@ -86,5 +86,5 @@
       Content.CollectionReset -= new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_CollectionReset);
       Content.UpdateOfRunsInProgressChanged -= new EventHandler(Content_UpdateOfRunsInProgressChanged);
-      Content.AlgorithmNameChanged -= new EventHandler(Content_AlgorithmNameChanged);
+      Content.OptimizerNameChanged -= new EventHandler(Content_AlgorithmNameChanged);
       DeregisterRunEvents(Content);
     }
@@ -159,5 +159,5 @@
 
     private void UpdateCaption() {
-      Caption = Content != null ? Content.AlgorithmName + "Box Plots" : ViewAttribute.GetViewName(GetType());
+      Caption = Content != null ? Content.OptimizerName + " Box Plots" : ViewAttribute.GetViewName(GetType());
     }
 
Index: branches/RuntimeOptimizer/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBubbleChartView.cs
===================================================================
--- branches/RuntimeOptimizer/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBubbleChartView.cs	(revision 8961)
+++ branches/RuntimeOptimizer/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBubbleChartView.cs	(revision 8971)
@@ -93,5 +93,5 @@
       Content.CollectionReset += new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_CollectionReset);
       Content.UpdateOfRunsInProgressChanged += new EventHandler(Content_UpdateOfRunsInProgressChanged);
-      Content.AlgorithmNameChanged += new EventHandler(Content_AlgorithmNameChanged);
+      Content.OptimizerNameChanged += new EventHandler(Content_AlgorithmNameChanged);
       RegisterRunEvents(Content);
     }
@@ -104,5 +104,5 @@
       Content.CollectionReset -= new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_CollectionReset);
       Content.UpdateOfRunsInProgressChanged -= new EventHandler(Content_UpdateOfRunsInProgressChanged);
-      Content.AlgorithmNameChanged -= new EventHandler(Content_AlgorithmNameChanged);
+      Content.OptimizerNameChanged -= new EventHandler(Content_AlgorithmNameChanged);
       DeregisterRunEvents(Content);
     }
@@ -175,5 +175,5 @@
 
     private void UpdateCaption() {
-      Caption = Content != null ? Content.AlgorithmName + "Bubble Chart" : ViewAttribute.GetViewName(GetType());
+      Caption = Content != null ? Content.OptimizerName + " Bubble Chart" : ViewAttribute.GetViewName(GetType());
     }
 
Index: branches/RuntimeOptimizer/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionDataTableView.cs
===================================================================
--- branches/RuntimeOptimizer/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionDataTableView.cs	(revision 8961)
+++ branches/RuntimeOptimizer/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionDataTableView.cs	(revision 8971)
@@ -63,5 +63,5 @@
       Content.CollectionReset += new CollectionItemsChangedEventHandler<IRun>(Content_CollectionReset);
       Content.UpdateOfRunsInProgressChanged += new EventHandler(Content_UpdateOfRunsInProgressChanged);
-      Content.AlgorithmNameChanged += new EventHandler(Content_AlgorithmNameChanged);
+      Content.OptimizerNameChanged += new EventHandler(Content_AlgorithmNameChanged);
     }
     protected override void DeregisterContentEvents() {
@@ -70,5 +70,5 @@
       Content.CollectionReset -= new CollectionItemsChangedEventHandler<IRun>(Content_CollectionReset);
       Content.UpdateOfRunsInProgressChanged -= new EventHandler(Content_UpdateOfRunsInProgressChanged);
-      Content.AlgorithmNameChanged -= new EventHandler(Content_AlgorithmNameChanged);
+      Content.OptimizerNameChanged -= new EventHandler(Content_AlgorithmNameChanged);
       base.DeregisterContentEvents();
     }
@@ -204,5 +204,5 @@
 
     private void UpdateCaption() {
-      Caption = Content != null ? Content.AlgorithmName + "Data Table" : ViewAttribute.GetViewName(GetType());
+      Caption = Content != null ? Content.OptimizerName + " Data Table" : ViewAttribute.GetViewName(GetType());
     }
 
Index: branches/RuntimeOptimizer/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionTabularView.cs
===================================================================
--- branches/RuntimeOptimizer/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionTabularView.cs	(revision 8961)
+++ branches/RuntimeOptimizer/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionTabularView.cs	(revision 8971)
@@ -65,5 +65,5 @@
       Content.CollectionReset += new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_CollectionReset);
       Content.UpdateOfRunsInProgressChanged += new EventHandler(Content_UpdateOfRunsInProgressChanged);
-      Content.AlgorithmNameChanged += new EventHandler(Content_AlgorithmNameChanged);
+      Content.OptimizerNameChanged += new EventHandler(Content_AlgorithmNameChanged);
       RegisterRunEvents(Content);
     }
@@ -78,5 +78,5 @@
       Content.CollectionReset -= new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_CollectionReset);
       Content.UpdateOfRunsInProgressChanged -= new EventHandler(Content_UpdateOfRunsInProgressChanged);
-      Content.AlgorithmNameChanged -= new EventHandler(Content_AlgorithmNameChanged);
+      Content.OptimizerNameChanged -= new EventHandler(Content_AlgorithmNameChanged);
       DeregisterRunEvents(Content);
     }
@@ -111,5 +111,5 @@
 
     private void UpdateCaption() {
-      Caption = Content != null ? Content.AlgorithmName + "Tabular View" : ViewAttribute.GetViewName(GetType());
+      Caption = Content != null ? Content.OptimizerName + " Tabular View" : ViewAttribute.GetViewName(GetType());
     }
 